#include <QCoreApplication>
#include <QHostInfo>
#include <QUdpSocket>
#include <QDebug>
#include <QDateTime>

int main(int argc, char ** argv)
{
    QCoreApplication a(argc, argv);

    QHostInfo host = QHostInfo::fromName("tik.cesnet.cz");

    QUdpSocket *s = new QUdpSocket;

    s->connectToHost(QHostAddress(host.addresses().at(0)), 123);

    // zprava pro NTP server - pozadavek
    s->write(QByteArray(48, 0x0b));

    if (s->waitForReadyRead())
    {
        while (s->hasPendingDatagrams())
        {
            QByteArray data = s->readAll();

            unsigned long cas = uchar(data[43]) + (uchar(data[42]) << 8) + (uchar(data[41]) << 16) + (uchar(data[40]) << 24);
            cas -= 2208988800U;
            QDateTime time = QDateTime::fromSecsSinceEpoch(cas);
	    qDebug() << time.toString("yyyy-MM-dd HH:mm:ss");
        }
    }

    delete s;

    return 0;
}
